#include <avr/io.h>
#include "i2c.h"
#include <ctype.h>
#include <avr/wdt.h>

// Empfangsspeicher 8-bit //
unsigned char status_2;
unsigned char status;
unsigned char status_RDS;
unsigned char resp1;
unsigned char resp2;
unsigned char resp3;
unsigned char resp4;
unsigned char resp4_2;
unsigned char resp5;
unsigned char resp5_2;
unsigned char resp6;
unsigned char resp7;
signed char resp7_2;
unsigned char resp8;
unsigned char resp9;
unsigned char resp10;
unsigned char resp11;
unsigned char resp12;
unsigned int Sender; // 16-bit
unsigned int Sender_2; // AM
unsigned char Minuten=32;
unsigned char Lo=0;
unsigned char Hi=0;
unsigned char Stunden=32;
unsigned char Utcoffset=0;
// Radio Text Speicher
unsigned char puffer_11=32;
unsigned char puffer_12=32;
unsigned char puffer_13=32;
unsigned char puffer_14=32;
unsigned char puffer_21=32;
unsigned char puffer_22=32;
unsigned char puffer_23=32;
unsigned char puffer_24=32;
unsigned char puffer_31=32;
unsigned char puffer_32=32;
unsigned char puffer_33=32;
unsigned char puffer_34=32;
unsigned char puffer_41=32;
unsigned char puffer_42=32;
unsigned char puffer_43=32;
unsigned char puffer_44=32;
/*unsigned char puffer_ps1=32;
unsigned char puffer_ps2=32;
unsigned char puffer_ps3=32;
unsigned char puffer_ps4=32;
unsigned char puffer_ps5=32;
unsigned char puffer_ps6=32;
unsigned char puffer_ps7=32;
unsigned char puffer_ps8=32;*/
unsigned char Radiotext [75];
int Zahler = 0;
int Zahlerbeginn = 0;
int BLOCK = 0;

unsigned char ps1=32;
unsigned char ps2=32;
unsigned char ps3=32;
unsigned char ps4=32;
unsigned char ps5=32;
unsigned char ps6=32;
unsigned char ps7=32;
unsigned char ps8=32;
unsigned char PS[8];
unsigned char PS_OUT[8];
unsigned char puffer_pi1=32;
unsigned char puffer_pi2=32;
unsigned char puffer_pi3=32;
unsigned char puffer_pi4=32;
unsigned int t=300;
unsigned char temp;
signed int pos;
int vorladen=0;
char Buffer [20]; // Speicherort bis zu 20 Zeichen
int Puffern_und_Laden = 0;
unsigned set;
unsigned char PTY[6];
char Temp[32]; // Character Temp kann bis zu 32 Bits(Zeichen) aufnehmen



void RDS_SET_ON (void)
{
	// RDS Konfiguration //
	
	start();
	send(0x22);
	send(0x12);
	send(0x00);
	send(0x15);
	send(0x01); //RDS Konfig. Befehl 15-02
	send(0x00); //Set Block Error A,B,C,D to 0 No Errors
	send(0xEF);
	stop();
	_delay_ms(100);
	
	start();
	send(0x22);
	send(0x12);
	send(0x00);
	send(0x15);
	send(0x02); //RDS Konfig. Befehl 15-02
	send(0x00); //Set Block Error A,B,C,D to BB FAST DECODING
	send(0x01);
	stop();
	_delay_ms(100);
}

void RDS_CLEAR(void)
{
	ps1=32;
	ps2=32;
	ps3=32;
	ps4=32;
	ps5=32;
	ps6=32;
	ps7=32;
	ps8=32;
	puffer_11=32;
	puffer_12=32;
	puffer_13=32;
	puffer_14=32;
	puffer_21=32;
	puffer_22=32;
	puffer_23=32;
	puffer_24=32;
	puffer_31=32;
	puffer_32=32;
	puffer_33=32;
	puffer_34=32;
	puffer_41=32;
	puffer_42=32;
	puffer_43=32;
	puffer_44=32;
	lcd_gotoxy( 0, 1 );
	lcd_puts("                    ");
	temp=0;
	for(int RT_CLEAR=0; RT_CLEAR<=75; RT_CLEAR++)
	Radiotext[RT_CLEAR]=32;
	for(int PS_CLEAR=0; PS_CLEAR<8; PS_CLEAR++)
	PS[PS_CLEAR]=32;
}
void RDS_SET_OFF (void)
{
	//RDS AUSSCHALTEN
	start();
	send(0x22);
	send(0x12);
	send(0x00);
	send(0x15);
	send(0x02); //RDS Konfig. Befehl 15-02
	send(0x00); //Set Block Error A,B,C,D to 0 No Errors
	send(0x00);
	stop();
}
int k=6;
int load=1;
unsigned char RDS;

void PROGRAMM_SERVICE ()
{// RDS Empfang //
	start();
	send(0x22); //Controllbyte
	send(0x24);
	send(0x01);
	stop();
	_delay_ms(20);
	start();
	send(0x23);
	status = empfack();
	resp1 = empfack();
	resp2 = empfack();
	resp3 = empfack();
	RDS = empfack();
	resp5 = empfack();
	resp6 = empfack();
	resp7 = empfack();
	resp8 = empfack();
	resp9 = empfack();
	resp10 = empfack();
	resp11 = empfack();
	resp12 = empfnack();
	stop();
	_delay_ms(10);
		
	if (resp10==0)resp10=32; // Lschen der Striche
	if (resp11==0)resp11=32;// Lschen der Striche
		
	// RDS Sendername //
		
	if ((resp6 >>4 == 0) && (resp2==1))
	{
			if(load==1)
			{
				resp7 &= 0x03;
				BLOCK=2*resp7;
				PS[BLOCK+0]=resp10;
				PS[BLOCK+1]=resp11;
				resp7 &= 0x03;
				if(BLOCK==6)load=0;
			}
			for(int write = 0; ((write <= 8)&&(load==0)); write ++)
			{PS_OUT[write]=PS[write];if(write==8)load=1;}
	}
}

int i = 0;
int j = 4;
double Load_value;

void RADIO_TEXT (signed char coder)
{wdt_enable(WDTO_2S); // Aktiviere den Wachhund! Beim Aufhngen des Controllers wird nach 2 Sekunden ein Reset-Interrupt ausgelst// RDS Empfang, Lauftext wird immitiert //
		start();
		send(0x22); //Controllbyte
		send(0x24);
		send(0x01);
		stop();
		_delay_ms(20);
		start();
		send(0x23);
		status = empfack();
		resp1 = empfack();
		resp2 = empfack();
		resp3 = empfack();
		resp4 = empfack();
		resp5 = empfack();
		resp6 = empfack()>>4;
		resp7 = empfack();
		resp8 = empfack();
		resp9 = empfack();
		resp10 = empfack();
		resp11 = empfack();
		resp12 = empfnack();
		stop();
		_delay_ms(20);
		
		if (resp8==0) // Lschen der Striche
		{
			resp8=32;
		}
		if (resp9==0) // Lschen der Striche
		{
			resp9=32;
		}
		if (resp10==0) // Lschen der Striche
		{
			resp10=32;
		}
		if (resp11==0) // Lschen der Striche
		{
			resp11=32;
		}
		// RDS Radio Text //
			
		
		if(resp2==1)
		{
			
			resp7 &= 0x0F; // Zhler 0 ===>> 15
			if((resp6 == 2) && (resp6>>3==0) && (BLOCK<60))
			{
				BLOCK=4*resp7;
				i=0;
				Radiotext[BLOCK+0]=resp8;
				Radiotext[BLOCK+1]=resp9;
				Radiotext[BLOCK+2]=resp10;
				Radiotext[BLOCK+3]=resp11;
				lcd_gotoxy(0,1);
				lcd_puts("RT: LOAD ");
				Load_value=(BLOCK*(5/3.));
				itoa( Load_value, Buffer, 10 );
				lcd_puts(Buffer);lcd_puts("%  ");
			}
		}
		
		
		if((i<49)&&(BLOCK==60))
		{
			lcd_gotoxy( 0, 1 );
			lcd_puts("RT:");
			i++;
			for(j=4; j<20; j++)
			{
			lcd_gotoxy(j,1);lcd_putc(Radiotext[i+j-4]);
			}
			if(i==0)_delay_ms(1000);
			wdt_reset();
			_delay_ms(250);
			wdt_reset();
			if(((BLOCK==60)&&(i==49))||(coder!=0))
			{
				lcd_gotoxy(0,1);
				lcd_puts("                    ");
				BLOCK=0;
				resp7=0;
			}
		}
}

void PROGRAMM_IDENTIFICATION_CODE (void)
{//PI-Code
	start();
	send(0x22); //Controllbyte
	send(0x24);
	send(0x01);
	stop();
	_delay_ms(20);
	start();
	send(0x23);
	status = empfack();
	resp1 = empfack();
	resp2 = empfack();
	resp3 = empfack();
	resp4 = empfack();
	resp5 = empfack();
	resp6 = empfack();
	resp7 = empfack();
	resp8 = empfack();
	resp9 = empfack();
	resp10 = empfack();
	resp11 = empfack();
	resp12 = empfnack();
	stop();
	_delay_ms(20);

	// PI Code Ausgabe

	puffer_pi1=resp4;
	puffer_pi2=resp5;
	if ((puffer_pi1==0)&&(puffer_pi2==0))
	{
		lcd_gotoxy( 2, 1 );
		lcd_puts("        ");
	}
	if ((puffer_pi1!=0)&&(puffer_pi2!=0))
	{
		lcd_gotoxy( 2, 1 );
		lcd_puts("PI:");
		lcd_gotoxy( 6, 1 );
		itoa( puffer_pi1, Buffer, 16 );
		lcd_puts(Buffer);
		lcd_gotoxy( 8, 1 );
		itoa( puffer_pi2, Buffer, 16 );
		lcd_puts(Buffer);	
	}
	_delay_ms(100);
}