#include <avr/io.h>
#include "LCD.h"
#define X_LENGTH 20 // Definiere LCD Zeilenlnge
#define Y_LENGTH 4 // Definiere LCD Spaltenlnge

// LCD Display HD44780U //
void LCD_START (void)
{
	lcd_init(LCD_DISP_ON); //LCD initialisieren...
	lcd_clrscr(); //Alle Zeichen lschen
}
// Steuerbares Lschprogramm
void CLEAR_LINE (int *X_LINE, int *Y_LINE, int *DELTA_X_LINE, int *DELTA_Y_LINE) // X_LINE und Y_LINE ist der Anfangswert, DELTA_X_LINE und DELTA_Y_LINE ist der Zwischenwert. 
{
	int COUNTER_X_LINE,COUNTER_Y_LINE;
	
	for(COUNTER_Y_LINE=*Y_LINE; ((COUNTER_Y_LINE<*DELTA_Y_LINE+*Y_LINE)&&(COUNTER_Y_LINE<Y_LENGTH)); COUNTER_Y_LINE++)
	for(COUNTER_X_LINE=*X_LINE; ((COUNTER_X_LINE<*DELTA_X_LINE+*X_LINE)&&(COUNTER_X_LINE<X_LENGTH)); COUNTER_X_LINE++)
	{
	lcd_gotoxy(COUNTER_X_LINE,COUNTER_Y_LINE);
	lcd_puts(" ");	
	}
}

void PS_AUSGABE (unsigned char PS[],signed char Senderwahl,int resp_4)
{
	int k=6;
	for(k=6; (k<=13); k++)// Ausgabe der Daten an LCD-Einheit
	{
		lcd_gotoxy(k,1);lcd_putc(PS[k-6]);
		wdt_reset();
		lcd_gotoxy(2,1);lcd_puts("PS:");
	}
	
	
	if(Senderwahl!=0)
	{
		for(int PS_CLEAR=0; PS_CLEAR<8; PS_CLEAR++)
		PS[PS_CLEAR]=32;
		lcd_gotoxy(2,1);lcd_puts("   ");
	}
}